// deliver.c
// The ct-if bot
// 08.09.2014
// 
// Copyright (C) 2015  Balthasar Szczepański
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/wait.h>

#define TEMP_PATH "/eizm/tmp/ong1/deliver."
#define LOG_PATH "/eizm/log/ong1/deliver.log"
#define POST_PATH "/eizm/mem/ong1/mpost/"
#define WAIT_PATH "/eizm/mem/ong1/mpost/wait/"
#define LS_PATH "/bin/ls"
#define MV_PATH "/bin/mv"
#define RM_PATH "/bin/rm"

pid_t sub;
int r;

int main(int argc, char **argv)
{
	time_t t;
	struct tm *nowS;
	int yarg;
	unsigned char text=0;
	unsigned char newlog=0;
	FILE *list;
	FILE *post;
	char temppath[256];
	unsigned char logopen=0;
	unsigned char i;
	char line[32];
	char value[32];
	char inpath[256];
	char outpath[256];
	unsigned char d;
	unsigned char m;
	unsigned short y;
	
	t=time(NULL);
	sprintf(temppath,"%s%lu",TEMP_PATH,(unsigned long)getpid());
	
	while((yarg = getopt(argc,argv,"tn")) != -1)
	{
		switch(yarg)
		{
		case 't':
			text=1;
			break;
		case 'n':
			newlog=1;
			break;
		default:
			
			break;
		}
	}
	if(!text)
	{
		if(freopen(LOG_PATH,newlog?"wt":"at",stdout)!=NULL)
			logopen=1;
	}
	setvbuf(stdout, NULL, _IONBF, 0);
	dup2(fileno(stdout),fileno(stderr));
	printf("\n%s",ctime(&t));
	
	sub=fork();
	if(sub==0)
	{
		if(freopen(temppath,"wt",stdout)==NULL)
			exit(255);
		r=execl(LS_PATH,LS_PATH,"-1","--color=never",WAIT_PATH,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("ls fail.\n");
	else
	{
		list=fopen(temppath,"rt");
		if(list==NULL)
			printf("list fail.\n");
		else
		{
			for(i=0; fgets(line,31,list)!=NULL; ++i)
			{
				sscanf(line,"%s",value);
				printf("%s",value);
				sprintf(inpath,"%s%s",WAIT_PATH,value);
				post=fopen(inpath,"rt");
				if(post==NULL)
				{
					printf(" fail.;");
					continue;
				}
				for(d=0xff,m=0xff,y=0xffff;fgets(line,31,post)!=NULL;)
				{
					if(line[0]=='d'&&line[1]=='=')
						sscanf(line+2,"%hhu",&d);
					else if(line[0]=='m'&&line[1]=='=')
						sscanf(line+2,"%hhu",&m);
					else if(line[0]=='y'&&line[1]=='=')
						sscanf(line+2,"%hu",&y);
				}
				fclose(post);
				printf(" %hhu.%hhu.%hu",d,m,y);
				nowS=localtime(&t);
				
				if(y>1900+nowS->tm_year)
				{
					printf(" wait\n");
					continue;
				}
				else if(y==1900+nowS->tm_year)
				{
					if(m>1+nowS->tm_mon)
					{
						printf(" wait\n");
						continue;
					}
					else if(m==1+nowS->tm_mon)
					{
						if(d>nowS->tm_mday)
						{
							printf(" wait\n");
							continue;
						}
					}
				}
				
				printf(" deliver");
				sprintf(outpath,"%s%s",POST_PATH,value);
				
				sub=fork();
				if(sub==0)
				{
					r=execl(MV_PATH,MV_PATH,inpath,outpath,(char *)0);
					exit(r);
				}
				waitpid(sub,&r,0);
				if(r)
					printf(" mv fail.\n");
				else
					printf(" ok\n");
			}
			if(i==0)
				printf("Nothing.\n");
			fclose(list);
			sub=fork();
			if(sub==0)
			{
				r=execl(RM_PATH,RM_PATH,"-f",temppath,(char *)0);
				exit(r);
			}
			waitpid(sub,&r,0);
			if(r)
				printf("rm fail.\n");
		}
	}
	if(logopen)
		fclose(stdout);
	return 0;
}
