// mpview.c (1190.bicyclesonthemoon.info/ct-if-v)
// Display one post
// 17.04.2015
// 
// Copyright (C) 2015  Balthasar Szczepański
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include <cgi.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

// #define RM_PATH "/bin/rm"
#define CAT_PATH "/bin/cat"
#define MAWK_PATH "/usr/bin/mawk"

#define NP_TOP_PATH "/eizm/www/time/aftertime/bftf/top"
#define NP_END_PATH "/eizm/www/time/aftertime/bftf/end"
#define INFO_PATH "/eizm/www/time/aftertime/bftf/info.htm"
#define POST_PATH "/eizm/mem/ong1/mpost/"
#define WAIT_PATH "/eizm/mem/ong1/mpost/wait/"

#define AWK_MVIEW "/eizm/pro/ong1/mview.awk"
#define TEMP_PATH "/eizm/tmp/ong1/mpview."

int main()
{
	s_cgi *cgi;
	pid_t sub;
	int r;
	
	char line[32];
	char filename[32];
	char postpath[256];
	char otherpath[256];
	char cat[8];
	char othercat[8];
	
	char *arg;
	
	FILE *file;
	
	unsigned char fff;
	
	cgi=cgiInit();
	fff=(cgiGetValue(cgi,"fff")!=NULL);
	
	arg=cgiGetValue(cgi,"v");
	sprintf(line,"%s",arg?arg:"???");
	if(line[0]=='c' && line[1]=='t')
	{
		sprintf(filename,"%s",line+2);
		sprintf(cat,"cat=%s","ct");
		sprintf(othercat,"%s","wt");
		sprintf(postpath,"%s%s",POST_PATH,filename);
		sprintf(otherpath,"%s%s",WAIT_PATH,filename);
	}
	else if(line[0]=='w' && line[1]=='t')
	{
		sprintf(filename,"%s",line+2);
		sprintf(cat,"cat=%s","wt");
		sprintf(othercat,"%s","ct");
		sprintf(postpath,"%s%s",WAIT_PATH,filename);
		sprintf(otherpath,"%s%s",POST_PATH,filename);
	}
	else 
	{
		printf("Status: 404 - Not found.\n\nNot this.\n");
		return 0;
		// sprintf(filename,"%s","???");
		// sprintf(postpath,"%s","???");
		// sprintf(cat,"cat=%s","???");
	}
	
	file=fopen(postpath,"rt");
	if(file==NULL)
	{
		file=fopen(otherpath,"rt");
		if(file==NULL)
		{
			printf("Status: 404 - Not found.\n\nNot this.\n");
			return 0;
		}
		fclose(file);
		sprintf(postpath,"/ct-if-v?v=%s%s%s",othercat,line+2,fff?"&fff=fff":"");
		cgiRedirect(postpath);
		return 0;
	}
	
	fclose(file);
	
	printf("Content-type: text/html\n\n");
	printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"\">\n");
	printf("<html lang=\"en\"><head>\n");
	printf("<title>Chronotransponder test interface &bull; Bicycles on the Moon</title>\n");
	printf("<meta http-equiv=\"Content-type\" content=\"text/html; charset=UTF-8\">\n");
	printf("<link rel=\"icon\" type=\"image/png\" href=\"/img/favicon.png\">\n");
	printf("<link rel=\"stylesheet\" href=\"/css/botm.css\">\n");
	printf("<script type=\"text/javascript\" src=\"/ott/prosilver/template/forum_fn.js\"></script>\n");
	printf("</head><body><a href=\"/\"><img src=\"/img/botmlogo2.png\" alt=\"1190.bicyclesonthemoon.info\" border=\"0\"></a>\n");
	printf("<h1>Chronotransponder test interface</h1>\n");
	
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_MVIEW,"-v","bg=1","-v",cat,"-v","s=1",postpath,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
	{
		printf("<div id=\"%s\" class=\"post bg1\">\n",line);
		printf("<div class=\"inner\"><span class=\"corners-top\"><span></span></span>\n");
		printf("%s %s POST NOT FOUND.\n",AWK_MVIEW,postpath);
		printf("<span class=\"corners-bottom\"><span></span></span>\n</div></div>\n");
		printf("<hr class=\"divider\"></hr>\n");
	}
	
	printf("<a href=\"/ct-if%s\">back to the chronotrasponder test interface</a><br>\n",fff?"?fff=fff":"");
	printf("<br><a href=\"/\">1190.bicyclesonthemoon.info</a></body></html>\n");
	
	return 0;
}
