// ongtext.c (1190.bicyclesonthemoon.info/ongtext)
// ONGtext generator
// 31.01.2015
// 
// Copyright (C) 2015  Balthasar Szczepański
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include <cgi.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

#define MAWK_PATH "/usr/bin/mawk"
#define AWK_ONGTEXT "/eizm/pro/ong1/ongtext.awk"
#define TEMP_PATH "/eizm/tmp/ong1/ongtext."
#define RM_PATH "/bin/rm"

int main (int argc, char **argv)
{
	s_cgi *cgi;
	pid_t sub;
	int r;
	
	char *value;
	
	unsigned char format=0;
	unsigned char decree=0;
	unsigned char output=0;
	unsigned char nohtml=0;
	
	char options[16];
	char temppath[247];
	char temppath2[256];
	
	setvbuf(stdout, NULL, _IONBF, 0);
	dup2(fileno(stdout),fileno(stderr));
	
	cgi=cgiInit();
	
	sprintf(temppath,"%s%lu",TEMP_PATH,(unsigned long)getpid());
	sprintf(temppath2,"tempfile=%s",temppath);
	
	if((value=cgiGetValue(cgi,"f"))!=NULL)
	{
		switch(value[0])
		{
		case 'o':
			format = 1;
			break;
		case 'u':
			format = 2;
			break;
		}
	}
	
	if(cgiGetValue(cgi,"d")!=NULL)
		decree=1;
	
	if(cgiGetValue(cgi,"b")!=NULL)
		output|=1;
	if(cgiGetValue(cgi,"h")!=NULL)
		output|=2;
	if(cgiGetValue(cgi,"t")!=NULL)
		nohtml=1;
	
	sprintf(options,"options=%s%s%s%s%s",format!=0?(format==1?"o":"u"):"",decree!=0?"d":"",(output&2)!=0?"h":"",(output&1)!=0?"b":"",nohtml!=0?"t":"");
	
	if(nohtml==0)
	{
		fputs("Content-type: text/html\n\n",stdout);
		fputs("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"\">\n",stdout);
		fputs("<html lang=\"en\"><head>\n",stdout);
		fputs("<title>ONGtext generator &bull; Bicycles on the Moon</title>\n",stdout);
		fputs("<meta http-equiv=\"Content-type\" content=\"text/html; charset=UTF-8\">\n",stdout);
		fputs("<link rel=\"icon\" type=\"image/png\" href=\"/img/favicon.png\">\n",stdout);
		fputs("<link rel=\"stylesheet\" href=\"/css/botm.css\">\n",stdout);
		fputs("</head><body><a href=\"/\"><img src=\"/img/botmlogo2.png\" alt=\"1190.bicyclesonthemoon.info\" border=\"0\"></a>\n",stdout);
		fputs("<h1>ONGtext generator</h1>\n",stdout);
	}
	else
		fputs("Content-type: text\n\n",stdout);
	if(format!=0)
	{
		sub=fork();
		if(sub==0)
		{
			r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_ONGTEXT,"-v",options,"-v",temppath2,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
		
		sub=fork();
		if(sub==0)
		{
			r=execl(RM_PATH,RM_PATH,"-f",temppath,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
	}
	
	if(nohtml==0)
	{
		
		fputs("<br>With the help of mrob27's <a href=\"http://mrob.com/time/automome\">automome</a>.<br>",stdout);
		fputs("<form method=\"get\" action=\"/ongtext\">\n",stdout);
		fputs("<br>\n",stdout);
		fprintf(stdout,"<input type=\"radio\" class=\"pt\" name=\"f\" value=\"o\"%s>ONG<br>\n",format!=2?" checked":"");
		fprintf(stdout,"<input type=\"radio\" class=\"pt\" name=\"f\" value=\"u\"%s>UNG<br>\n",format==2?" checked":"");
		fputs("<br>\n",stdout);
		fprintf(stdout,"<input type=\"checkbox\" class=\"pt\" name=\"d\"%s>decree<br>\n",decree!=0?" checked":"");
		fputs("<br>\n",stdout);
		fprintf(stdout,"<input type=\"checkbox\" class=\"pt\" name=\"h\"%s>HTML<br>\n",(output&2)!=0?" checked":"");
		fprintf(stdout,"<input type=\"checkbox\" class=\"pt\" name=\"b\"%s>BBcode<br>\n",(output&1)!=0?" checked":"");
		fputs("<br>\n",stdout);
		fputs("<input type=\"checkbox\" class=\"pt\" name=\"t\">text only<br>\n",stdout);
		fputs("<br>\n",stdout);	
		fputs("<input type=\"submit\" class=\"pk\" value=\"Generate\">\n",stdout);
		fputs("</form><br>\n",stdout);
		fputs("<a href=\"/ongtextsrc/\">source</a><br><br>\n",stdout);
		fputs("<a href=\"/\">1190.bicyclesonthemoon.info</a></body></html>\n",stdout);
	}
	return 0;
}