// posted.c (1190.bicyclesonthemoon.info/ct-if)
// Display the post list
// 23.11.2014
// 
// Copyright (C) 2014  Balthasar Szczepański
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include <cgi.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

#define TEMP_PATH "/eizm/tmp/ong1/posted."
#define MPOST_PATH "/eizm/mem/ong1/mpost/"
#define WAIT_PATH "/eizm/mem/ong1/mpost/wait/"
#define LS_PATH "/bin/ls"
#define RM_PATH "/bin/rm"
#define MAWK_PATH "/usr/bin/mawk"
#define AWK_POSTED "/eizm/pro/ong1/posted.awk"

s_cgi *cgi;
pid_t sub;
int r;

int main(int argc, char **argv)
{
	char temppath[256]="";
	char line[32];
	char filename[32];
	char postpath[256];
	FILE *tempfile;
	// FILE *postfile;
	unsigned char i;
	unsigned char fff;
	// dup2(fileno(stdout),fileno(stderr));
	cgi=cgiInit();
	fff=(cgiGetValue(cgi,"fff")!=NULL);
	
	sprintf(temppath,"%s%lu",TEMP_PATH,(unsigned long)getpid());
	
	printf("Content-type: text/html\n\n");
	printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"\">\n");
	printf("<html lang=\"en\"><head>\n");
	printf("<title>Chronotransponder test interface &bull; Bicycles on the Moon</title>\n");
	printf("<meta http-equiv=\"Content-type\" content=\"text/html; charset=UTF-8\">\n");
	printf("<link rel=\"icon\" type=\"image/png\" href=\"/img/favicon.png\">\n");
	printf("<link rel=\"stylesheet\" href=\"/css/botm.css\">\n");
	printf("</head><body><a href=\"/\"><img src=\"/img/botmlogo2.png\" alt=\"1190.bicyclesonthemoon.info\" border=\"0\"></a>\n");
	printf("<h1>Chronotransponder test interface</h1>\n");
	
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		if(freopen(temppath,"wt",stdout)==NULL)
			exit(255);
		r=execl(LS_PATH,LS_PATH,"-1","--color=never",MPOST_PATH,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("No messages.<br>\n");
	else
	{
		printf("<table class=\"pl\"><tr class=\"pls\"><td colspan=\"5\">CT</td></tr>\n");
		printf("<tr class=\"plt\"><td class=\"plk\">sent</td><td class=\"plk\">received</td><td class=\"plk\">author</td><td class=\"plk\">subject</td><td class=\"plk\">action</td></tr>\n");
		
		tempfile=fopen(temppath,"rt");
		if(tempfile!=NULL)
		{
			for(i=0; fgets(line,31,tempfile)!=NULL; ++i)
			{
				sscanf(line,"%s",filename);
				sprintf(postpath,"%s%s",MPOST_PATH,filename);
				
				fflush(stdout);
				sub=fork();
				if(!sub)
				{
					r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_POSTED,"-v",i&0x1?"r2=1":"r2=0","-v","cat=ct","-v",fff?"fff=fff":"f=f",postpath,(char *)0);
					exit(r);
				}
				waitpid(sub,&r,0);
				
			}
			fclose(tempfile);
		}
		printf("</table><br><b><a href=\"/ct-if-p%s\">Send a message</a></b><br>\n",fff?"?fff=fff":"");

	}
	
	// if(fff)
	// {
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		if(freopen(temppath,"wt",stdout)==NULL)
			exit(255);
		r=execl(LS_PATH,LS_PATH,"-1","--color=never",WAIT_PATH,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("No messages.<br>\n");
	else
	{
		printf("<br><table class=\"pl\"><tr class=\"pls\"><td colspan=\"5\">WAIT</td></tr>\n");
		printf("<tr class=\"plt\"><td class=\"plk\">sent</td><td class=\"plk\">to be received</td><td class=\"plk\">author</td><td class=\"plk\">subject</td><td class=\"plk\">action</td></tr>\n");
		
		tempfile=fopen(temppath,"rt");
		if(tempfile!=NULL)
		{
			for(i=0; fgets(line,31,tempfile)!=NULL; ++i)
			{
				sscanf(line,"%s",filename);
				sprintf(postpath,"%s%s",WAIT_PATH,filename);
				
				fflush(stdout);
				sub=fork();
				if(!sub)
				{
					r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_POSTED,"-v",i&0x1?"r2=1":"r2=0","-v","cat=wt","-v",fff?"fff=fff":"f=f",postpath,(char *)0);
					exit(r);
				}
				waitpid(sub,&r,0);
				if(r)
				--i;
				
			}
			fclose(tempfile);
		}
		
		printf("</table>%s\n",fff?"<br><b><a href=\"/ct-if-f\">Force delivery</a></b><br>":"");
	}
// }
	
	printf("<br><a href=\"/\">1190.bicyclesonthemoon.info</a></body></html>\n");
	
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(RM_PATH,RM_PATH,"-f",temppath,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	
	return 0;
}
