#// preview.awk
#// Preview a post in the post edit interface
#// 05.10.2014
#// 
#// Copyright (C) 2014  Balthasar Szczepański
#// 
#// This program is free software: you can redistribute it and/or modify
#// it under the terms of the GNU Affero General Public License as
#// published by the Free Software Foundation, either version 3 of the
#// License, or (at your option) any later version.
#// 
#// This program is distributed in the hope that it will be useful,
#// but WITHOUT ANY WARRANTY; without even the implied warranty of
#// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#// GNU Affero General Public License for more details.
#// 
#// You should have received a copy of the GNU Affero General Public License
#// along with this program.  If not, see <http://www.gnu.org/licenses/>.

BEGIN{
	postpath="/eizm/mem/ong1/mpost/"
	waitpath="/eizm/mem/ong1/mpost/wait/"
	
	HTML="<div class=\"pl\"><div class=\"pls\">Preview: %s</div><div class=\"plw\">%s</div></div><br>"
	wrong="<div class=\"plt\"><b>%s</b></div>\n"
	subject="<input type=\"text\" name=\"subject\" id=\"subject\" size=\"40\" maxlength=\"60\" tabindex=\"1\" value=\"%s\" class=\"pt\">\n"
	username="<input tabindex=\"2\" name=\"username\" id=\"username\" size=\"40\" value=\"%s\" class=\"pt\" type=\"text\">\n"
	time="<b>day: </b><input tabindex=\"3\" name=\"d\" id=\"day\" size=\"2\" value=\"%s\" class=\"pt\" type=\"text\"><b> month: </b><input tabindex=\"4\" name=\"m\" id=\"month\" size=\"2\" value=\"%s\" class=\"pt\" type=\"text\"><b> year: </b><input tabindex=\"5\" name=\"y\" id=\"year\" size=\"4\" value=\"%s\" class=\"pt\" type=\"text\">\n"
	message="<textarea name=\"message\" id=\"message\" rows=\"20\" tabindex=\"6\" class=\"pt\" >%s%s</textarea>\n"
	forcetime1="<input type=\"text\" name=\"forcetime\" id=\"forcetime\" size=\"16\" maxlength=\"32\" value=\"%s\" class=\"pt\">\n"
	forcetime2="<tr><td><b>fTime: </b></td><td><b>day: </b><input name=\"dd\" id=\"fday\" size=\"2\" value=\"%s\" class=\"pt\" type=\"text\"><b> month: </b><input name=\"mm\" id=\"fmonth\" size=\"2\" value=\"%s\" class=\"pt\" type=\"text\"><b> year: </b><input name=\"yy\" id=\"fyear\" size=\"4\" value=\"%s\" class=\"pt\" type=\"text\"></tr>\n"
	future="<input type=\"hidden\" name=\"fff\" value=\"fff\">"
	img="<input type=\"button\" class=\"pk\" accesskey=\"p\" name=\"addbbcode14\" value=\"Img\" style=\"width: 40px\" onclick=\"bbstyle(14)\" title=\"Insert image: [img]http://image_url[/img]\" >"
	back="<a href=\"/ct-if%s\">back to the chronotransponder interface</a>\n"
	hidden="<input type=\"text\" name=\"hidden\" size=\"1\" class=\"pt\" value=\"%s\">\n"
	addquote=""
	
	# print "<!--preview.awk:\nargfile=" argfile
	while((getline argline < argfile)>0)
	{
		gsub(/[\r\n]/,"",argline)
		eq=index(argline,"=")
		argtab[substr(argline,1,eq-1)]=substr(argline,eq+1)
		# print substr(argline,1,eq-1) "=" argtab[substr(argline,1,eq-1)]
	}
	# print "-->"
	close(argfile)
	if(argtab["addquote"] ~ /^[cw]t[0-9]+$/)
	{
		if(argtab["addquote"] ~ /^ct[0-9]+$/)
			argfile= postpath substr(argtab["addquote"],3)
		if(argtab["addquote"] ~ /^wt[0-9]+$/)
			argfile= waitpath substr(argtab["addquote"],3)
		#else
			#argfile is not changed = quote self?
		while((getline argline < argfile)>0)
		{
			gsub(/[\r\n]/,"",argline)
			eq=index(argline,"=")
			if(argline ~ /^BBHTML=/)
			{
				addquotehtml=substr(argline,eq+1)
				gsub(/<br>/,"\n",addquotehtml)
			}
			if(argline ~ /^username_h=/)
				addquotename=substr(argline,eq+1)
			if(argline ~ /^subject_h/)
			{
				addquotesub=substr(argline,eq+1)
				if(addquotesub ~ /^Re:/)
					argtab["subject"]=addquotesub
				else
					argtab["subject"]="Re: "addquotesub
			}
			if(argline ~ /^timetext/)
			{
				addquotetime=", at "substr(argline,eq+1)
			}
			if(argline ~ /^yy=/)
			{
				argtab["y"]=substr(argline,eq+1)
			}
			if(argline ~ /^dd=/)
			{
				argtab["d"]=substr(argline,eq+1)
			}
			if(argline ~ /^mm=/)
			{
				argtab["m"]=substr(argline,eq+1)
			}
			if(argline ~ /^y=/)
			{
				argtab["yy"]=substr(argline,eq+1)
			}
			if(argline ~ /^d=/)
			{
				argtab["dd"]=substr(argline,eq+1)
			}
			if(argline ~ /^m=/)
			{
				argtab["mm"]=substr(argline,eq+1)
			}
		}
		close(argfile)
		if(addquotehtml!="")
			addquote="[quote=&quot;"addquotename addquotetime"&quot;]"addquotehtml"[/quote]"
	}
};
{
	if ($0 ~ /^###HTML/)
	{
		if((argtab["HTML"]!="")&&(argtab["wrong"]==""))
			printf(HTML,argtab["subject"],argtab["HTML"])
	}
	else if ($0 ~ /^###wrong/)
	{
		if(argtab["wrong"]!="")
			printf(wrong,argtab["wrong"])
	}
	else if ($0 ~ /^###subject/)
			printf(subject,((argtab["subject"]=="")?"???":argtab["subject"]))
	else if ($0 ~ /^###username/)
		printf(username,argtab["username"])
	else if ($0 ~ /^###message/)
		printf(message,argtab["message"],addquote)
	else if ($0 ~ /^###time/)
		printf(time,argtab["d"],argtab["m"],argtab["y"])
	else if ($0 ~ /^###forcetime1/)
	{
		if(fff!="")
			printf(forcetime1,argtab["forcetime"])
	}
	else if ($0 ~ /^###forcetime2/)
	{
		if(fff!="")
			printf(forcetime2,argtab["dd"],argtab["mm"],argtab["yy"])
	}
	else if ($0 ~ /^###future/)
	{
		if(fff!="")
			print future
	}
	else if ($0 ~ /^###hidden/)
	{
		if(fff!="")
			printf(hidden,argtab["hidden"])
	}
	else if ($0 ~ /^###img/)
	{
		if(fff!="")
			print img
	}
	else if ($0 ~ /^###back/)
	{
		printf(back,fff!=""?"?fff=fff":"")
	}
	else if ($0 ~ /^###debug/)
	{
		gsub(/###nl;/,"\n",argtab["debug"])
		gsub(/-/," - ",argtab["debug"])
		print "<!-- "argtab["debug"]" -->"
	}
	else
		print $0
};
