// update.c (1190.bicyclesonthemoon.info/aftertime/remove)
// update demustarded frames to viewer
// 17.04.2015
// 
// Copyright (C) 2015  Balthasar Szczepański
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#define ONG_STATE_PATH "/eizm/data/aftertime/bftf/ongstate"
#define FRAME_PRINTF   "/eizm/data/aftertime/bftf/%hu.png"
#define ONGED_PRINTF   "/eizm/www/time/aftertime/bftf/bftf-%04hu.png"
#define CP_PATH        "/bin/cp"

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/wait.h>

pid_t sub;
int r;

int main (int argc, char *argv[])
{
	FILE *file;
	unsigned short i,ongFrame;
	unsigned char ongState;
	char framePath[64];
	char ongedPath[64];
	
	file=fopen(ONG_STATE_PATH,"rt");
	if(file!=NULL)
	{
		fscanf(file,"%hhu %hu",&ongState,&ongFrame);
		fclose(file);
	}
	else
	{
		ongState=0;
		ongFrame=0;
	}
	
	for(i=0;i<=ongFrame;++i)
	{
		
		sprintf(framePath,FRAME_PRINTF,i);
		sprintf(ongedPath,ONGED_PRINTF,i);
		
		sub=fork();
		if(!sub)
		{
			r=execl(CP_PATH,CP_PATH,framePath,ongedPath,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
		if(r)
			return r;
	}
	
	return 0;
}